/**************************************************************/
/*                                                            */
/*                                                            */
/*  Written by Jim MacNair - October, 1997                    */
/*                                                            */
/*                                                            */
/**************************************************************/

/**************************************************************/
/* Definitions for Standard header in CICS COMMAREA           */
/**************************************************************/
#include "stdhead.h"

/**************************************************************/
/* Definitions of various CICS fields                         */
/**************************************************************/

#define MAX_USERID_LEN 8
#define MAX_PW_LEN 8
#define MAX_SYS_NAME_LEN 8
#define MAX_PROG_NAME_LEN 8
#define MAX_CLIENT_NAME_LEN 4
#define ABCODE_LEN 4

/**************************************************************/
/* Defines for ECI ERROR Variables                            */
/**************************************************************/

#define ECI_ERR_MSG		"ECIERRMSG"
#define ECI_ERR_CODE	"ECIERRCODE"
#define ECI_ERR_ABCODE	"ECIERRABCODE"
#define ECI_ERR_SYSERR	"ECIERRSYSERR"
#define ECI_ERR_HR		"ECIERRHR"
#define ECI_ERR_NL		"ECIERRNL"
#define ECI_HR			"<hr>"
#define ECI_NEWLINE		"<p>"

/**************************************************************/
/* Function prototype definitions                             */
/**************************************************************/

char* Print_ECI_Error(int rc);

int performECI(const char *pgmName, const char *userid, const char *pw, 
			   const char *sysid, char *pCommArea, int commLen, VARSTRUCT *pVars, 
			   char *abendcode, int *token);

int perfECIext(const char *pgmName, const char *userid, const char *pw, 
			   const char *sysid, char *pCommArea, int commLen, VARSTRUCT *pVars, 
			   char *abendcode, int *token);

int perfCommit(const char *pgmName, const char *userid, const char *pw, 
			   const char *sysid, char *pCommArea, int commLen, VARSTRUCT *pVars, 
			   char *abendcode, int *token);

void setStandardHeader(pCOMMHEAD ca, 
					   long calen, 
					   int maplen, 
					   char *mapname, 
					   char *tranname,
 					   char *cics_client_name);

/****************/
/* End of File  */
/****************/