// Ecisubs.h: interface for the CEcisubs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ECISUBS_H__27627145_95C6_11D2_BDD3_204C4F4F5020__INCLUDED_)
#define AFX_ECISUBS_H__27627145_95C6_11D2_BDD3_204C4F4F5020__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

////////////////////////////////////////////////////////////////
// Required include for CICS ECI calls
////////////////////////////////////////////////////////////////
#include <cicseci.hpp>
#include "cics_eci.h"

// Include for standard COMMAREA header
#include "stdhead.h"

class CEcisubs : public CObject  
{
public:
	CEcisubs();
	virtual ~CEcisubs();

	static int executeCICSTran(const char* tran, 
						long casize, 
						void *dataArea, 
						const char* cics_system,
						const char* cics_user,
						const char* cics_pw,
						CString& cics_message,
						CString& cics_abcode);

	static const char* getECImessage(int rc);

	static void setStandardHeader(pCOMMHEAD ca, 
							      long calen, 
								  int maplen, 
								  char * mapname, 
								  char * tranname,
								  CString& cics_client_name);

	static void dumpStandardHeader(pCOMMHEAD ca, CDumpContext& dc);
};

#endif // !defined(AFX_ECISUBS_H__27627145_95C6_11D2_BDD3_204C4F4F5020__INCLUDED_)
