// This code is to fix a bug in the CICS clients
// If this subclassing is not done, then by the time
// your main code gets control in a catch block,
// the abend code will have been reset

class fixCclECI : public CclECI {

public:
	// variable to expose the CICS transaction abend code.
	CString m_Cclabcode;

	void handleException(CclException exception) 

	{
		// Set the abend code to null
		m_Cclabcode.Empty();
		// check for a CICS transaction abend
		if ((Ccl::ExCode) exception.exCode() == Ccl::transaction)
		{
			// Try and get a pointer to the CclFlow object
			CclFlow* pflo = (CclFlow*) exception.exObject();
			if (pflo != NULL)
			{
				//Have the pointer, get the CICS Transaction abend code
				m_Cclabcode = pflo->abendCode();
				// needed to avoid a rethrow from Destructor
				// I told you this was a bug
				pflo->forceReset();
			}
		}

		// rethrow the exception
		throw (exception);
	}
};
