#if !defined(AFX_LOGISA_H__F4E4B0E4_F72B_11D1_BC4D_204C4F4F5020__INCLUDED_)
#define AFX_LOGISA_H__F4E4B0E4_F72B_11D1_BC4D_204C4F4F5020__INCLUDED_

// LOGISA.H - Header file for your Internet Server
//    logisa Extension

#include "resource.h"

//////////////////////////////////////////////////////////
#include <cicseci.hpp>
//////////////////////////////////////////////////////////

// CICS ECI object subclass to correct bug in clients
#include "clnterr.h"

// definitions for variable table 
#include "vartable.h"

// CICS COMMAREA definition
#include "VERIFYPW.H"

class CLogisaExtension : public CHttpServer
{
public:
//	void procLogon(CHttpServerContext* pCtxt, LPTSTR submit, LPTSTR cicsuser, LPTSTR cicspw, LPTSTR cicssys, LPTSTR cicsclient);
	CLogisaExtension();
	~CLogisaExtension();

// Overrides
	// ClassWizard generated virtual function overrides
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//{{AFX_VIRTUAL(CLogisaExtension)
	public:
	virtual BOOL GetExtensionVersion(HSE_VERSION_INFO* pVer);
	virtual BOOL OnParseError(CHttpServerContext* pCtxt, int nCause);
	//}}AFX_VIRTUAL

	// TODO: Add handlers for your commands here.
	// For example:

	void Default(CHttpServerContext* pCtxt);
	void procTest(CHttpServerContext* pCtxt, LPTSTR submit);
	void procLogon(CHttpServerContext* pCtxt, 
					 LPTSTR cicsuser, 
					 LPTSTR cicspw, 
					 LPTSTR cicssys, 
					 LPTSTR cicsclient, 
					 LPTSTR submit);

	DECLARE_PARSE_MAP()

	//{{AFX_MSG(CLogisaExtension)
	//}}AFX_MSG
private:
	int executeCICSTran(char* tran, int casize, void *dataArea, CString& cics_system, CString& cics_user, CString& cics_pw, CString& cics_message, CString& cics_abcode);
	void to_comm(CString & submit, char * CommField, int maxLen, int isNumber);
	static void int_to_comm(const long i, char *result, const int len);
	int performLogon(Cvartable & vars, int* RCode);
	void build_commarea(Cvartable& vars, VERIFYCOMM *pCommArea);
	void generateFilename(char* filename, const char* clientname, const char* systemname);
	int	saveTempfileData(char* filename, 
						 CString& user, 
						 CString& pw, 
						 CString& client, 
						 CString& sys,
						 int replay,
						 const int tctualen,
						 const char* tctua);
	static void writeTraceLine(const char* traceData);
	static void dumpArea(const char* traceData, const int len);
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOGISA_H__F4E4B0E4_F72B_11D1_BC4D_204C4F4F5020__INCLUDED)
